diff --git a/include/flecs.h b/include/flecs.h
index a551511cc..e6bf26a1d 100644
--- a/include/flecs.h
+++ b/include/flecs.h
@@ -338,6 +338,7 @@ extern ecs_type_t
     TEcsDisabledIntern,
     TEcsInactive,
     TEcsOnDemand,
+    TEcsMonitor,
     TEcsPipeline,
     TEcsPipelineQuery,
     TEcsTimer,
@@ -359,26 +360,27 @@ extern ecs_type_t
 #define EEcsDisabledIntern (12)
 #define EEcsInactive (13)
 #define EEcsOnDemand (14)
-#define EEcsPipeline (15)
-#define EEcsPipelineQuery (16)
-#define EEcsTimer (17)
-#define EEcsRateFilter (18)
-#define EEcsTickSource (19)
+#define EEcsMonitor (15)
+#define EEcsPipeline (17)
+#define EEcsPipelineQuery (18)
+#define EEcsTimer (19)
+#define EEcsRateFilter (20)
+#define EEcsTickSource (21)
 
 /* Builtin pipeline tags */
-#define EcsPreFrame (20)
-#define EcsOnLoad (21)
-#define EcsPostLoad (22)
-#define EcsPreUpdate (23)
-#define EcsOnUpdate (24)
-#define EcsOnValidate (25)
-#define EcsPostUpdate (27)
-#define EcsPreStore (28)
-#define EcsOnStore (29)
-#define EcsPostFrame (30)
+#define EcsPreFrame (22)
+#define EcsOnLoad (23)
+#define EcsPostLoad (24)
+#define EcsPreUpdate (25)
+#define EcsOnUpdate (26)
+#define EcsOnValidate (27)
+#define EcsPostUpdate (28)
+#define EcsPreStore (29)
+#define EcsOnStore (30)
+#define EcsPostFrame (31)
 
 /** Builtin entity ids */
-#define EcsWorld (31)
+#define EcsWorld (32)
 #define ECS_SINGLETON (EcsSingleton)
 
 /** Value used to quickly check if component is builtin */
diff --git a/include/flecs/util/vector.h b/include/flecs/util/vector.h
index 2e559439f..0e0f19ab8 100644
--- a/include/flecs/util/vector.h
+++ b/include/flecs/util/vector.h
@@ -186,10 +186,10 @@ ecs_vector_t* _ecs_vector_copy(
 
 #define ecs_vector_each(vector, T, var, ...)\
     {\
-        int i, count = ecs_vector_count(vector);\
+        int var##_i, count = ecs_vector_count(vector);\
         T* array = ecs_vector_first(vector);\
-        for (i = 0; i < count; i ++) {\
-            T* var = &array[i];\
+        for (var##_i = 0; var##_i < count; var##_i ++) {\
+            T* var = &array[var##_i];\
             __VA_ARGS__\
         }\
     }
diff --git a/src/builtin.c b/src/builtin.c
index 3d7eaf0f9..f21d12a3b 100644
--- a/src/builtin.c
+++ b/src/builtin.c
@@ -244,9 +244,6 @@ void ecs_init_system_builtins(
     ECS_TRIGGER(world, EcsOnAddPipeline, EcsOnAdd, EcsPipeline, 0);
     ECS_TRIGGER(world, EcsOnSetSystem, EcsOnSet, EcsSystem, 0);
 
-    // ECS_WATCH(world, EcsSystemEnabled, EcsSystem, !EcsDisabled, !EcsDisabledIntern);
-    // ECS_WATCH(world, EcsSystemDisabled, EcsSystem, EcsDisabled || EcsDisabledIntern);
-
     world->builtin_pipeline = ecs_new_pipeline(world, "EcsBuiltinPipeline",
         "EcsPreFrame, EcsOnLoad, EcsPostLoad, EcsPreUpdate, EcsOnUpdate,"
         " EcsOnValidate, EcsPostUpdate, EcsPreStore, EcsOnStore, EcsPostFrame");
diff --git a/src/entity.c b/src/entity.c
index 4c43482b7..2f0a6dd42 100644
--- a/src/entity.c
+++ b/src/entity.c
@@ -608,6 +608,54 @@ void ecs_run_deinit_actions(
     }
 }
 
+static
+void run_monitors(
+    ecs_world_t *world, 
+    ecs_stage_t *stage, 
+    ecs_table_t *dst_table, 
+    ecs_data_t *dst_data, 
+    int32_t dst_row, 
+    int32_t count, 
+    ecs_table_t *src_table)
+{
+    if (!dst_table->monitors) {
+        return;
+    }
+
+    if (!src_table->monitors) {
+        ecs_vector_each(dst_table->monitors, ecs_monitor_t, monitor, {
+            ecs_run_monitor(world, stage, monitor, dst_row, count);
+        });
+    } else {
+        /* If both tables have monitors, run the ones that dst_table has and
+         * src_table doesn't have */
+        int32_t i, count = ecs_vector_count(dst_table->monitors);
+        int32_t j = 0, src_count = ecs_vector_count(src_table->monitors);
+        ecs_monitor_t *dst_monitors = ecs_vector_first(dst_table->monitors);
+        ecs_monitor_t *src_monitors = ecs_vector_first(src_table->monitors);
+
+        for (i = 0; i < count; i ++) {
+            ecs_monitor_t *dst = &dst_monitors[i];
+
+            ecs_monitor_t *src = 0;
+            while (j < src_count) {
+                src = &src_monitors[j];
+                if (src->system < dst->system) {
+                    j ++;
+                } else {
+                    break;
+                }
+            }
+
+            if (src->system == dst->system) {
+                continue;
+            }
+
+            ecs_run_monitor(world, stage, dst, dst_row, count);
+        }
+    }
+}
+
 static
 uint32_t new_entity(
     ecs_world_t *world,
@@ -649,15 +697,7 @@ uint32_t new_entity(
 
     run_init_actions(world, stage, new_table, dst_data, new_row, 1, *added);
 
-    ecs_vector_t *new_systems = new_table->on_new;
-    // if (new_systems) {
-    //     int32_t i, count = ecs_vector_count(new_systems);
-    //     ecs_entity_t *sys_array = ecs_vector_first(new_systems);
-
-    //     for (i = 0; i < count; i ++) {
-    //         //TODO invoke on_new trigger
-    //     }
-    // }
+    run_monitors(world, stage, new_table, dst_data, new_row, 1, NULL);
 
     info->data = dst_data;
     
@@ -723,6 +763,8 @@ uint32_t move_entity(
             world, stage, dst_table, dst_data, dst_row, 1, *added);
     }
 
+    run_monitors(world, stage, dst_table, dst_data, dst_row, 1, src_table);
+
     info->data = dst_data;
 
     return dst_row;
@@ -810,7 +852,7 @@ void commit(
             ecs_assert(!world->max_handle || entity <= world->max_handle, ECS_OUT_OF_RANGE, 0);
             ecs_assert(entity >= world->min_handle, ECS_OUT_OF_RANGE, 0);
         }
-    }    
+    }
 }
 
 static
@@ -948,6 +990,8 @@ int32_t new_w_data(
         }
     }
 
+    run_monitors(world, stage, table, data, row, count, NULL);
+
     return row;
 }
 
diff --git a/src/flecs_private.h b/src/flecs_private.h
index 5de1877b6..0001ce8d7 100644
--- a/src/flecs_private.h
+++ b/src/flecs_private.h
@@ -167,6 +167,17 @@ void ecs_table_register_query(
     ecs_table_t *table,
     ecs_query_t *query);
 
+void ecs_table_register_monitor(
+    ecs_world_t *world,
+    ecs_table_t *table,
+    ecs_entity_t system,
+    int32_t matched_table_index);
+
+void ecs_table_unregister_monitor(
+    ecs_world_t *world,
+    ecs_table_t *table,
+    ecs_entity_t system);
+
 /* Deinitialize table. This invokes all matching on_remove systems */
 void ecs_table_deinit_components(
     ecs_world_t *world,
@@ -231,6 +242,20 @@ void ecs_query_match_table(
     ecs_query_t *query,
     ecs_table_t *table);
 
+void ecs_query_set_monitor(
+    ecs_world_t *world,
+    ecs_query_t *query,
+    bool is_monitor);
+
+void ecs_query_set_rows(
+    ecs_world_t *world,
+    ecs_stage_t *stage,
+    ecs_query_t *query,
+    ecs_rows_t *rows,
+    int32_t table_index,
+    int32_t row,
+    int32_t count);
+
 ////////////////////////////////////////////////////////////////////////////////
 //// Signature API
 ////////////////////////////////////////////////////////////////////////////////
@@ -329,6 +354,12 @@ void ecs_measure_system_time(
     ecs_world_t *world,
     bool enable);
 
+void ecs_run_monitor(
+    ecs_world_t *world,
+    ecs_stage_t *stage,
+    ecs_monitor_t *monitor,
+    int32_t row,
+    int32_t count);
 
 ////////////////////////////////////////////////////////////////////////////////
 //// Worker API
diff --git a/src/query.c b/src/query.c
index e0940a590..be011c7eb 100644
--- a/src/query.c
+++ b/src/query.c
@@ -129,7 +129,16 @@ void order_ranked_tables(
     ecs_world_t *world,
     ecs_query_t *query)
 {
-    ecs_vector_sort(query->tables, ecs_matched_table_t, table_compare);
+    if (query->rank_table) {
+        ecs_vector_sort(query->tables, ecs_matched_table_t, table_compare);
+    }
+
+    if (query->is_monitor) {
+        ecs_vector_each(query->tables, ecs_matched_table_t, table, {
+            ecs_table_register_monitor(
+                world, table->table, query->system, table_i);
+        })
+    }
 }
 
 static
@@ -1037,7 +1046,7 @@ void ecs_query_activate_table(
     bool active)
 {
     ecs_vector_t *src_array, *dst_array;
-    
+
     if (active) {
         src_array = query->inactive_tables;
         dst_array = query->tables;
@@ -1134,6 +1143,23 @@ void ecs_rematch_query(
     }
 }
 
+void ecs_query_set_monitor(
+    ecs_world_t *world,
+    ecs_query_t *query,
+    bool is_monitor)
+{
+    ecs_assert(!is_monitor || query->system != 0, ECS_INTERNAL_ERROR, NULL);
+
+    query->is_monitor = is_monitor;
+
+    if (is_monitor) {
+        ecs_vector_each(query->tables, ecs_matched_table_t, table, {
+            ecs_table_register_monitor(
+                world, table->table, query->system, table_i);
+        });
+    }
+}
+
 /* -- Public API -- */
 
 ecs_query_t* ecs_query_new_w_sig(
@@ -1243,6 +1269,39 @@ ecs_query_iter_t ecs_query_iter(
     };
 }
 
+void ecs_query_set_rows(
+    ecs_world_t *world,
+    ecs_stage_t *stage,
+    ecs_query_t *query,
+    ecs_rows_t *rows,
+    int32_t table_index,
+    int32_t row,
+    int32_t count)
+{
+    ecs_matched_table_t *table = ecs_vector_get(
+        query->tables, ecs_matched_table_t, table_index);
+    ecs_assert(table != NULL, ECS_INTERNAL_ERROR, NULL);
+
+    ecs_table_t *world_table = table->table;
+    ecs_data_t *table_data = ecs_table_get_staged_data(world, stage, world_table);
+    ecs_entity_t *entity_buffer = ecs_vector_first(table_data->entities);            
+    rows->entities = &entity_buffer[row];
+
+    rows->world = world;
+    rows->query = query;
+    rows->column_count = ecs_vector_count(query->sig.columns);
+    rows->table_count = 1;
+    rows->inactive_table_count = 0;
+    rows->table = world_table;
+    rows->table_columns = table_data->columns;
+    rows->columns = table->columns;
+    rows->components = table->components;
+    rows->references = ecs_vector_first(table->references);
+    rows->offset = row;
+    rows->count = count;
+}
+
+
 /* Return next table */
 bool ecs_query_next(
     ecs_query_iter_t *iter)
diff --git a/src/system.c b/src/system.c
index 81258dcee..81eec83b3 100644
--- a/src/system.c
+++ b/src/system.c
@@ -277,9 +277,16 @@ void ecs_init_system(
          * columns of the on demand system, disable it */
         if (!system_data->on_demand->count) {
             ecs_add(world, system, EcsDisabledIntern);
+            
+            system_data = ecs_get_mut(world, system, EcsColSystem, NULL);
+            ecs_assert(system_data != NULL, ECS_INTERNAL_ERROR, NULL);
         }        
     }
 
+    if (ecs_has(world, system, EcsMonitor)) {
+        ecs_query_set_monitor(world, system_data->query, true);
+    }
+
     ecs_trace_pop();
 }
 
@@ -488,6 +495,25 @@ ecs_entity_t ecs_run(
     return ecs_run_w_filter(world, system, delta_time, 0, 0, NULL, param);
 }
 
+void ecs_run_monitor(
+    ecs_world_t *world,
+    ecs_stage_t *stage,
+    ecs_monitor_t *monitor,
+    int32_t row,
+    int32_t count)
+{
+    ecs_entity_t system = monitor->system;
+    const EcsColSystem *system_data = ecs_get_ptr(world, system, EcsColSystem);
+    ecs_assert(system_data != NULL, ECS_INTERNAL_ERROR, NULL);
+
+    ecs_rows_t rows = {0};
+    ecs_query_set_rows( world, stage, system_data->query, &rows, 
+        monitor->matched_table_index, row, count);
+
+    rows.system = system;
+    system_data->action(&rows);
+}
+
 bool ecs_is_enabled(
     ecs_world_t *world,
     ecs_entity_t system)
diff --git a/src/table.c b/src/table.c
index ffd13df83..abf1ed4ca 100644
--- a/src/table.c
+++ b/src/table.c
@@ -166,6 +166,84 @@ void ecs_table_register_query(
     }
 }
 
+int compare_entity(
+    const void *ptr1,
+    const void *ptr2)
+{
+    const ecs_monitor_t *m1 = ptr1;
+    const ecs_monitor_t *m2 = ptr2;
+    return m1->system - m2->system;
+}
+
+/* This function is called when a query is matched with a table. A table keeps
+ * a list of tables that match so that they can be notified when the table
+ * becomes empty / non-empty. */
+void ecs_table_register_monitor(
+    ecs_world_t *world,
+    ecs_table_t *table,
+    ecs_entity_t system,
+    int32_t matched_table_index)
+{
+    ecs_assert(system != 0, ECS_INTERNAL_ERROR, NULL);
+
+    /* First check if system is already registered as monitor. It is possible
+     * the query just wants to update the matched_table_index (for example, if
+     * query tables got reordered) */
+    ecs_vector_each(table->monitors, ecs_monitor_t, m, {
+        if (m->system == system) {
+            m->matched_table_index = matched_table_index;
+            return;
+        }
+    });
+
+    /* Monitor hasn't been registered with table, register it now */
+    ecs_monitor_t *m = ecs_vector_add(&table->monitors, ecs_monitor_t);
+    ecs_assert(m != NULL, ECS_INTERNAL_ERROR, NULL);
+
+    m->system = system;
+    m->matched_table_index = matched_table_index;
+
+    /* Sort the vector so we can quickly compare monitors between tables */
+    qsort(
+        ecs_vector_first(table->monitors), 
+        ecs_vector_count(table->monitors), 
+        sizeof(ecs_monitor_t), 
+        compare_entity);
+
+#ifndef NDEBUG
+    char *str = ecs_type_str(world, table->type);
+    ecs_trace_1("monitor #[green]%s#[reset] registered with table #[red]%s",
+        ecs_get_name(world, system), str);
+    ecs_os_free(str);
+#endif
+}
+
+void ecs_table_unregister_monitor(
+    ecs_world_t *world,
+    ecs_table_t *table,
+    ecs_entity_t system)
+{
+    bool removed = false;
+
+    ecs_vector_each(table->monitors, ecs_monitor_t, m, {
+        if (m->system == system) {
+            ecs_vector_remove_index(table->monitors, ecs_monitor_t, m_i);
+            removed = true;
+            break;
+        }
+    });
+
+    if (!removed) {
+        return;
+    }
+
+    qsort(
+        ecs_vector_first(table->monitors), 
+        ecs_vector_count(table->monitors), 
+        sizeof(ecs_monitor_t), 
+        compare_entity);    
+}
+
 static
 ecs_data_t* ecs_table_get_data_intern(
     ecs_world_t *world,
diff --git a/src/table_graph.c b/src/table_graph.c
index 39979c424..41f6b691c 100644
--- a/src/table_graph.c
+++ b/src/table_graph.c
@@ -123,7 +123,6 @@ void init_table(
     init_edges(world, stage, table);
 
     table->queries = NULL;
-    table->on_new = NULL;
 }
 
 static
diff --git a/src/types.h b/src/types.h
index 4af167692..f04b7fe20 100644
--- a/src/types.h
+++ b/src/types.h
@@ -100,6 +100,12 @@ typedef struct ecs_edge_t {
     ecs_table_t *remove;
 } ecs_edge_t;
 
+/* Table monitor */
+typedef struct ecs_monitor_t {
+    ecs_entity_t system;
+    int32_t matched_table_index;
+} ecs_monitor_t;
+
 /** A table is the Flecs equivalent of an archetype. Tables store all entities
  * with a specific set of components. Tables are automatically created when an
  * entity has a set of components not previously observed before. When a new
@@ -112,8 +118,8 @@ struct ecs_table_t {
     /* Only set when table has data */
     ecs_vector_t *stage_data;         /* Data per stage */
     ecs_vector_t *queries;            /* Queries matched with table */
-    ecs_vector_t *on_new;             /* Systems executed when new entity is
-                                       * added to table */
+    ecs_vector_t *monitors;           /* Monitor systems */
+
     int32_t *dirty_state;             /* Keep track of changes in columns */
     int32_t flags;                    /* Flags for testing table properties */
 };
@@ -168,6 +174,7 @@ struct ecs_query_t {
     bool match_prefab;          /* Does query match prefabs */
     bool match_disabled;        /* Does query match disabled */
     bool has_refs;              /* Does query have references */
+    bool is_monitor;            /* Should query register as monitor? */
     int32_t cascade_by;         /* Identify CASCADE column */
     bool needs_matching;        /* Does sig need to be matched with tables */
 };
diff --git a/src/world.c b/src/world.c
index a8f631d6b..13ae23e95 100644
--- a/src/world.c
+++ b/src/world.c
@@ -16,6 +16,7 @@ ecs_type_t TEcsDisabled;
 ecs_type_t TEcsDisabledIntern;
 ecs_type_t TEcsInactive;
 ecs_type_t TEcsOnDemand;
+ecs_type_t TEcsMonitor;
 ecs_type_t TEcsPipeline;
 ecs_type_t TEcsPipelineQuery;
 ecs_type_t TEcsTimer;
@@ -36,6 +37,7 @@ static const char *ECS_DISABLED_NAME =       "EcsDisabled";
 static const char *ECS_DISABLED_INTERN_NAME ="EcsDisabledIntern";
 static const char *ECS_INACTIVE_NAME =       "EcsInactive";
 static const char *ECS_ON_DEMAND_NAME =      "EcsOnDemand";
+static const char *ECS_MONITOR_NAME =        "EcsMonitor";
 static const char *ECS_PIPELINE_NAME =       "EcsPipeline";
 static const char *ECS_PIPELINE_QUERY_NAME = "EcsPipelineQuery";
 static const char *ECS_TIMER_NAME =          "EcsTimer";
@@ -79,6 +81,7 @@ void bootstrap_types(
     TEcsDisabledIntern = bootstrap_type(world, EEcsDisabledIntern);
     TEcsInactive = bootstrap_type(world, EEcsInactive);
     TEcsOnDemand = bootstrap_type(world, EEcsOnDemand);
+    TEcsMonitor = bootstrap_type(world, EEcsMonitor);
     TEcsPipeline = bootstrap_type(world, EEcsPipeline);
     TEcsPipelineQuery = bootstrap_type(world, EEcsPipelineQuery);
     TEcsTimer = bootstrap_type(world, EEcsTimer);
@@ -348,6 +351,7 @@ ecs_world_t *ecs_init(void) {
     bootstrap_component(world, table, EEcsDisabledIntern, ECS_DISABLED_INTERN_NAME, 0);
     bootstrap_component(world, table, EEcsInactive, ECS_INACTIVE_NAME, 0);
     bootstrap_component(world, table, EEcsOnDemand, ECS_ON_DEMAND_NAME, 0);
+    bootstrap_component(world, table, EEcsMonitor, ECS_MONITOR_NAME, 0);
     bootstrap_component(world, table, EEcsPipeline, ECS_PIPELINE_NAME, 0);
     bootstrap_component(world, table, EEcsPipelineQuery, ECS_PIPELINE_QUERY_NAME, sizeof(EcsPipelineQuery));
     bootstrap_component(world, table, EEcsTimer, ECS_TIMER_NAME, sizeof(EcsTimer));
